//file: bindery.h
//		implementation for bindery and date classes

#ifndef Bindery_H_
#define Bindery_H_

#include "utility.h"
#include <string.h>

class Date
{
friend ostream &operator<<(ostream &out, Date &src);

public:
   Date();
   Date(int newyear, int newmonth, int newday);
   ~Date();

   void GetInput(ostream &out, istream &in);
   void Set(int newyear, int newmonth, int newday);
   bool higherThan(Date &Src);
   bool lowerThan(Date &Src);

private:
   int year, month, day;
};

ostream &operator<<(ostream &out, Date &src);

class Bindery
{
public:
   Bindery();
   ~Bindery();

   void Set(int newbook, char *newcondition, double newcost);
   int GetBook();
   char *GetCondition();
   double GetCost();

public:
   Date Sent;           // date book was sent to bindery
   Date Returned;       // date book will be returned from bindery

private:
   int book;            // id of book at bindery
   char condition[Max_Len];   // why book is sent to bindery
   double cost;         // cost of sending book to bindery
};

#endif