//file: book.cc

#include <iostream.h>
#include "book.h"

Book :: Book()
: title  (NULL)
, author (NULL)
, number (0)
, status (-1)
, owner  (0)
{
}

Book :: Book(char *newtitle, char *newauthor, int newnumber)
: title  (NULL)
, author (NULL)
, number (0)
, status (-1)
, owner  (0)
{
   Init(newtitle, newauthor, newnumber);
}

Book :: Book(Book &src)
: title  (NULL)
, author (NULL)
, number (0)
, status (-1)
, owner  (0)
{
   // use the 'operator=' overload defined below to do copying
   (*this) = src;
}

Book :: ~Book()
{
   delete[] title;
   delete[] author;
}

void Book :: Init(char *newtitle, char *newauthor, int newnumber)
{
   if (title != NULL)
   {
      delete[] title;
      title = NULL;
   }

   title = new char [strlen(newtitle) + 1];
   strcpy(title, newtitle);

   if (author != NULL)
   {
      delete[] author;
      author = NULL;
   }

   author = new char [strlen(newauthor) + 1];
   strcpy(author, newauthor);

   number = newnumber;
}

void Book :: Print(ostream &out)
{
   out << "\"" << title << "\" by " << author << "(#" << number << ")";
}

Book& Book :: operator=(Book &src)
{
   Init(src.title, src.author, src.number);
   status = src.status;
   owner = src.owner;

   return (*this);
}

int Book :: GetNumber()
{
   return number;
}

int Book :: GetStatus()
{
   return status;
}

void Book :: SetStatus(int newstatus)
{
   status = newstatus;
}

int Book :: GetOwner()
{
   return owner;
}

void Book :: SetOwner(int newowner)
{
   owner = newowner;
}

void Book :: Write(ostream &out)
{
   out << title << endl << author << endl
      << number << ' ' << status << ' ' << owner << endl;
}

ostream &operator<<(ostream &out, Book &src)
{
   src.Print(out);
   return (out);
}