/*****************************************************************************

	[book.h] Book class prototype
	By Jeff Leung

*****************************************************************************/
#ifndef BOOK_H
#define BOOK_H

#include <cstring>
#include <string>
#include <stdlib.h>
#include "item.h"

using namespace std;

class Book : public Item
{
public:
	Book();
	virtual ~Book();

	virtual string getIDProp(void);
	virtual string getName(unsigned int);
	virtual string getValue(string &);
	virtual string getDesc(string &);
	virtual return_value setProp(string &, string &);
	virtual unsigned int numProps(void);

	bool isBorrowed(void);
	bool isDue(void);
	bool SetBorrower(Item *, string &);
	void ClearBorrower(void);
	bool InitBorrower(Item *);

protected:
private:
	string	sISBN,			// isbn
			sTitle,			// title
			sAuthor,		// author
			sPublisher,		// publisher
			sOutDate,		// checked out date (DD MMM YYYY) ie "01 JAN 2001"
			sDueDate,		// due date (DD MMM YYYY)
			sBorrower;		// id of client currently borrowing book

	Item	*pBorrower;		// customer currently borrowing book
};

#endif