/*****************************************************************************

	[client.h] Client class prototype
	By Jeff Leung

*****************************************************************************/
#ifndef CLIENT_H
#define CLIENT_H

#include <cstring>
#include <string>
#include <vector>
#include "item.h"

using namespace std;

class Client : public Item
{
public:
	Client();
	virtual ~Client();

	virtual string getIDProp(void);
	virtual string getName(unsigned int);
	virtual string getValue(string &);
	virtual string getDesc(string &);
	virtual return_value setProp(string &, string &);
	virtual unsigned int numProps(void);

	bool hasDue(void);
	bool isBorrowing(void);
	bool Borrow(Item *, string &);
	bool Return(Item *);
	bool InitBorrowed(Item *);
	unsigned int numBorrowed(void);
	Item *getBorrowed(unsigned int);

private:
	string	sID,			// unique identifier for customer
			sFirstName,		// first name
			sLastName;		// last name

	vector<Item*> aBorrow;	// array of pointers to books borrowed
};

#endif