//------------------------------------------------------------------------------
// File: cylinder.h
// Desc: Declaration and Definitions for 'cylinder' class.
//------------------------------------------------------------------------------
#ifndef _CYLINDER_H
#define _CYLINDER_H

//_[headers]____________________________________________________________________
//
#include "circle.h"			// flat circle class, used as base for cylinder
#include <iostream.h>		// i/o streaming (cout)

//_[cylinder class]_____________________________________________________________
//
class cylinder : public circle
{
public:

	//--------------------------------------------------------------------------
	// Name: cylinder()
	// Desc: Constructor.
	//--------------------------------------------------------------------------
	cylinder(float NewRadius = 12.3, float NewHeight = 42.1)
	: Height(NewHeight)
	, circle(NewRadius)
	{
	}

	//--------------------------------------------------------------------------
	// Name: print()
	// Desc: Displays info about cylinder (see comment for 'shape::print()').
	//--------------------------------------------------------------------------
	virtual print()
	{
		cout << "Cylinder:" << endl;
		cout << "Area of cylinder is " << area() << endl;
		cout << "Circumference of base circle is " << circumference() << endl;
		cout << "Radius of base circle is " << Radius << endl;
		cout << "Height of cylinder is " << Height << endl;
	}

protected:

	//--------------------------------------------------------------------------
	// Name: area()
	// Desc: Calculates the surface area of the cylinder.
	//--------------------------------------------------------------------------
	virtual area()
	{
		return 2 * PI * Radius * (Height + Radius);
	}

	//--------------------------------------------------------------------------
	// Name: volume()
	// Desc: Calculates the volume of the cylinder.
	//--------------------------------------------------------------------------
	virtual volume()
	{
		return circle::area() * Height;
	}

	//--------------------------------------------------------------------------
	// Name: Height
	// Desc: Height of cylinder.
	//--------------------------------------------------------------------------
	float Height;

}; // cylinder

#endif