#include<fstream.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>
#include "words.h"

char* GetWord( ifstream &input, int &location ) {
  // returns a pointer to the next word or NULL if one wasn't found

  const int maxlinelen = 1024;
  static char line[maxlinelen] = { '\0' };
  static char word[maxlinelen];
  static char *pt = line;
  static int linenum = 0;
  char *wp;

  // set found word to blank
  word[0] = '\0';

  // loop until a new word is found OR EOF is encountered
  do
  {

    // if reached end of line, get a new one
    if ( *pt == '\0' ) {

      // get line
      input.getline(line, maxlinelen);

      // if reached EOF, return NULL
      if (input.eof())
      {
        location = 0;
        return NULL;
      }

      // explicitly terminate with NULL character just in case
      line[maxlinelen - 1] = '\0';

      // reset position pointer
      pt = line;

      // increment line number
      linenum++;
    }

    // move to next word
    while ( *pt && isalpha(*pt) == 0 ) {
      pt++;
    }

    // if no alphabetic characters were found, read another line
    if ( *pt == '\0' )
      continue;

    // otherwise read this word
    wp = word;
    while ( isalpha(*pt) ) {
      *wp = *pt;
      pt++;
      wp++;
    }
    *wp = '\0';

  } while ( word[0] == '\0' );

  // set the location (line number)
  location = linenum;

  // return found word
  return word;
}

