//file: library.h

#ifndef Library_H_
#define Library_H_

#include <fstream.h>       // ifstream
#include "book.h"
#include "card.h"
#include "utility.h"
#include "bindery.h"

const int Max_AtBindery = 100;

class Library
{
public:
   Library(ifstream &inFile);
   ~Library();
   void DoCommand(char cmd);

private:
   Card cardList[Max_Len];
   Book bookList[Max_Len];
   Bindery bindList[Max_AtBindery];
   int cardcount;
   int bookcount;
   int bindcount;

// helper functions
private:
   Bool ReadBook(Book &book, ifstream &inFile);
   Bool ReadCard(Card &card, ifstream &inFile);
   void ShowAllBooks();
   void ShowAllCards();
   void CheckOutBook();
   void CheckInBook();
   void AddBook();
   void NewCard();
   void PrintBook();
   void SendToBindery();
};

#endif