<?

class XNLSection
{
	var $name;
	var $para;
	var $uname;
	var $uhref;
	var $pi;
	
	function XNLSection()
	{
		$this->para = array();
		$this->uname = array();
		$this->uhref = array();
		$this->pi = 0;
	}
}

$xnl_num	= 0;
$xnl_day	= 0;
$xnl_month	= 0;
$xnl_year	= 0;
$xnl_sec	= array();
$xnl_si		= 0;
$xnl_buf	= '';

function startXNLElement($parser, $name, $attrs)
{
	global $xnl_buf, $xnl_sec, $xnl_si;

	if ($name == 'NEWSLETTER')
	{
		global $xnl_num, $xnl_day, $xnl_month, $xnl_year;
		$xnl_num	= (int)$attrs['NUM'];
		$xnl_day	= (int)$attrs['DAY'];
		$xnl_month	= (int)$attrs['MONTH'];
		$xnl_year	= (int)$attrs['YEAR'];
	}
	else if ($name == 'SECTION')
	{
		$xnl_sec[$xnl_si] = new XNLSection();
		$xnl_sec[$xnl_si]->name = $attrs['NAME'];
	}
	else if ($name == 'URL')
	{
		$xnl_sec[$xnl_si]->uname[$xnl_sec[$xnl_si]->pi] = $attrs['NAME'];
		$xnl_sec[$xnl_si]->uhref[$xnl_sec[$xnl_si]->pi] = $attrs['HREF'];
		$xnl_sec[$xnl_si]->para[$xnl_sec[$xnl_si]->pi] = '';
		$xnl_sec[$xnl_si]->pi++;
	}
	else if ($name == 'PARA')
	{
	}

	$xnl_buf = '';
}

function endXNLElement($parser, $name)
{
	global $xnl_si;
	if ($name == 'NEWSLETTER')
	{
	}
	else if ($name == 'SECTION')
	{
		$xnl_si++;
	}
	else if ($name == 'URL')
	{
	}
	else if ($name == 'PARA')
	{
		global $xnl_sec, $xnl_si, $xnl_buf;
		$xnl_sec[$xnl_si]->para[$xnl_sec[$xnl_si]->pi] = ltrim(rtrim($xnl_buf));
		$xnl_sec[$xnl_si]->pi++;
	}
}

function insideXNLElement($parser, $data)
{
	$GLOBALS['xnl_buf'] .= $data;
}

function FormatXNL($fn, $type)
{
	global $xnl_sec, $xnl_si;

	$xnl_si = 0;
	$xnl_sec = array();

	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startXNLElement", "endXNLElement");
	xml_set_character_data_handler($xml_parser, "insideXNLElement");
	if (!($fp = fopen($fn, "r"))) {
		die("could not open XML input");
	}

	while ($data = fread($fp, 4096)) {
		if (!xml_parse($xml_parser, $data, feof($fp))) {
			die(sprintf("XML error: %s at line %d",
					xml_error_string(xml_get_error_code($xml_parser)),
					xml_get_current_line_number($xml_parser)));
		}
	}

	xml_parser_free($xml_parser);

	if (strtolower($type) == 'html')
		return FormatXNL_HTML();
	else
		return FormatXNL_Text();
}

function FormatXNL_HTML()
{
	global $xnl_num, $xnl_sec, $xnl_si, $xnl_day, $xnl_month, $xnl_year;

	$fodate = date(', F jS, Y', mktime(0,0,0,$xnl_month,$xnl_day,$xnl_year));

	$ret = '';

	$ret .= "<HR>\n";
	$ret .= "<FONT SIZE=+2>Neil Stuff Newsletter</FONT> #";
	$ret .= sprintf('%03d', $xnl_num);
	$ret .= $fodate;
	$ret .= "\n<HR>\n";
	$ret .= "<BR><DL>\n";

	for ($i = 0; $i < $xnl_si; $i++)
	{
		$sec =& $xnl_sec[$i];

		$ret .= "<DT><FONT SIZE=+1><B>{$sec->name}</B></FONT></DT><DD>\n";

		for ($j = 0; $j < $sec->pi; $j++)
		{
			if ($sec->para[$j] != '')
			{
				$ret .= wordwrap("{$sec->para[$j]}<BR><BR>");
			}
			else
			{
				$ret .= "<CENTER><A HREF=\"{$sec->uhref[$j]}\">{$sec->uname[$j]}</A> ({$sec->uhref[$j]})</CENTER><BR>\n";
			}
		}

		$ret .= "</DD>\n";
		unset($sec);
	}

	$ret .= "</DL>";

	return $ret;
}

function FormatXNL_Text()
{
	global $xnl_num, $xnl_sec, $xnl_si, $xnl_day, $xnl_month, $xnl_year;

	$fodate = date(': F jS, Y', mktime(0,0,0,$xnl_month,$xnl_day,$xnl_year));

	$ret = '';

	$ret .= "***************************************";
	$ret .= "************************************\n";
	$ret .= "Neil Stuff Newsletter #";
	$ret .= sprintf('%03d', $xnl_num);
	$ret .= $fodate;
	$ret .= "\n**************************************";
	$ret .= "*************************************\n";
	$ret .= "\n\n";

	for ($i = 0; $i < $xnl_si; $i++)
	{
		$sec =& $xnl_sec[$i];

		$title = "_[{$sec->name}]";
		$x = 75 - strlen($title);
		for ($xi = 0; $xi < $x; $xi++)
			$title .= '_';
		$ret .= "$title\n\n";

		for ($j = 0; $j < $sec->pi; $j++)
		{
			if ($sec->para[$j] != '')
			{
				$ret .= wordwrap($sec->para[$j]);
				$ret .= "\n\n";
			}
			else
			{
				$utext = $sec->uname[$j] . ' (' . $sec->uhref[$j] . ')';
				$x = (int)((75 - strlen($utext)) / 2);
				$sp = '';
				for ($xi = 0; $xi < $x; $xi++)
					$sp .= ' ';
				$utext = $sp . $utext;
				$ret .= "$utext\n\n";
			}
		}
		
		unset($sec);
	}

	return $ret;
}

?>