/****************************** File Prologue *******************************

University of Maryland University College
Introductory Programming in C/C++
CMIS-140
Section xxxx

~~~~~~~~~~
ASSIGNMENT
~~~~~~~~~~
Programming Project 6

~~~~~~~~~
FILE NAME
~~~~~~~~~
rational.h

~~~~~~
AUTHOR
~~~~~~
<Your Name>
<Your e-mail address>

~~~~~~~~~~~
DESCRIPTION
~~~~~~~~~~~

  This file contains the specification of the Rational class. Please see the
  class definition below for details.


****************************************************************************/

/*------------------------------ [INCLUDES] -------------------------------*/
#include <iostream>

using namespace std;

/*----------------------------- [DATA TYPES] ------------------------------*/

class Rational
{
    public:

        // default constructor;  initializes fraction to 0/1
        Rational();

        // Precondition:  denominator != 0
        Rational(long numerator, long denominator);

        // adds the object to otherFrac and returns the result
        Rational Add (Rational otherFrac) const;

        // subtracts otherFrac from the object and returns the result
        Rational Subtract (Rational otherFrac) const;

        // multiplies the object by otherFrac and returns the result
        Rational Multiply (Rational otherFrac) const;

        // divides the object by otherFrac and returns the result
        // Precondition:  otherFrac != Rational(0, 1)
        enum DivideStatus {SUCCESS, DIVIDE_BY_ZERO};
        Rational Divide (Rational otherFrac, DivideStatus& divStat) const;


        // compares the object with otherFrac for equality
        bool IsEqualTo (Rational otherFrac) const;

        // reads a rational number from the input stream in n/m format
        void Read (istream& is);

        // writes the object out to the screen in n/m format.
        void Write (ostream& os) const;

        long Numerator() const;             // returns value of numerator
        long Denominator() const;           // returns value of denominator

        // Sets the value of an existing rational object
        void Set (long numerator, long denominator);

    private:

        // reduces the fraction to its "simplest" form
        void Reduce();

        // conventionally prefix m_ is used to indicate a data member
        long m_numerator;
        long m_denominator;
};

