
<I><B>Whether you need a killer application or to complete a simple project, I can provide a variety of services in a discrete, timely manner based on your needs and requirements.  Satisfaction guaranteed!</B></I><SUP><A HREF="#guarantee">*</A></SUP><BR>
<BR>

Contents of this document:<BR>
<UL>
	<LI><A HREF="#intro">Introduction</A>
	<LI><A HREF="#steps">Steps to Contracting a Project</A>
	<LI><A HREF="#guarantee">Satisfaction Guarantee</A>
	<LI><A HREF="#faq">Frequently Asked Questions</A>
	<LI><A HREF="#terms">Terms of Agreement</A>
</UL>
<BR>

<A NAME="intro"><H2>Introduction</H2></A>

	I'm currently providing the following <A HREF="#guarantee">guaranteed</A> high quality, discrete, part-time services:

	<UL>
		<LI><B>C++</B> applications, COM components, and utilities using STL, BeAPI, Win32, and/or DirectX for Windows, BeOS, or Linux
		<LI><B>Java</B> applets, servlets, and applications using Swing
		<LI><B>C#</B> applications and utilities
		<LI><B>PHP</B> web applications and utilities
		<LI><B>CGI</B> using C++ or Perl
		<LI><B>Basic</B> applications and utilities using VisualBasic or QBasic/QuickBasic
		<LI><B>ASP</B> web applications using VBScript or JScript
		<LI><B>Technical Consultation</B> based on my experiences and knowledge base.  Simple questions are answered <A HREF="<?echo(meu('qa'));?>">free of charge</A>.
	</UL>

	These are <I>only</I> those capabilities which I am <B>willing to sell as services</B>, not a full list of my skills.  For detailed information about my qualifications, please request a resume via <A HREF="mailto:masta@gibdon.com">email</A>.  If you need my physical address (including a phone number), please give me yours and I'll send the information there.<BR>
	<BR>

<A NAME="steps"><H2>Steps to Contracting a Project</H2></A>

<OL>

	<LI><B>Read this entire document</B>
		<BR><BR>
		This document explains every thing you need to know about my contracting services and should be read in full before you proceed any further.<BR>
		<BR>

	<LI><B>Contact me</B>
		<BR><BR>
		<A HREF="mailto:masta@gibdon.com">Email me at masta@gibdon.com</A> with an overview of the project and request an estimate.  Please include as many details as you feel comfortable sharing about the project and explicitely mention that you would like an estimate.  None of your information will be divulged to anyone, except those with authentic authority who specifically require it (local officials, FBI, etc.).<BR>
		<BR>

	<LI><A NAME="negotiate"><B>Negotiate</B></A>
		<BR><BR>
		At this point I will reply to your original email and we will negotiate the remaining details such as cost, project specifications, and deadlines.  Terms in <I>addition</I> to the <A HREF="#terms">ones provided</A> may also be negotiated.  I do not currently have the time for personal negotations (face to face); if your project is large and requires this then I won't be able to apply myself to it anyway.<BR>
		<BR>
		<A NAME="projdetail">Among the details of the project itself, the following must be worked out:</A><BR>
		<BR>
		<UL>
			<LI> <B>Paid number of hours</B>:  Your budget and my time.  If I estimate a price that is out of your range, feel free to haggle.  I might not accept, but I might.  Be <I>very</I> convincing.<BR>
			<BR>

			<LI> <B>Documentation</B>:  By default I will not write out additional documents beyond the source: flow charts, UML charts, developer documentation, user documentation, specifications, etc.<BR>
			<BR>

			<LI> <B>Starting date</B> and <B>Deadline(s)</B>:  There should be no questions about when I am to have finished the project and sent it to you.  The starting date is usually when I receive your deposit.  The deadline should be a <I>specific</I> date <I>and</I> time.  If you say "by day <I>X</I>", I will assume that I have up until day <I>X</I> as well as the day itself.  All time I specify is based on Pacific Standard Time (West Coast, United States).<BR>
			<BR>

			<LI> <B>Coding Style</B>: If you have a specific coding style, notation, conventions, etc. that you want me to use please explain or provide a document explaining them.  By default I will use my own style.<BR>
			<BR>

			<LI> <B>Technical requirements</B>:
				<UL>
				<LI> Coding language. [default=c++]
				<LI> Target platform. [default=Win32]
				<LI> For C/C++, use character strings (char[]) or STL strings. [default=character strings]
				<LI> For C++, use templates? [default=no]
				<LI> For C++, use STL extensively? [default=no]
				</UL>
				<BR>
			<LI> <B>Status reports</B> and their requested frequency.<BR>
			<BR>
		</UL>

	<LI><B>Deposit</B>
		<BR><BR>
		If everything is agreed upon I require an initial deposit of $250 or &frac14;, whichever is greater, but no more than &frac12;.  I will usually not start on a project until I receive this.  It also signifies that you've read this entire document and agree to my <A HREF="#terms">terms</A>.<BR>
		<BR>

	<LI><B>Obtaining the product</B>
		<BR><BR>
		After I believe I am finished creating the product you require, I will email you.  The product will typically be included via an attachment as well as be on a download location on this or another web server.<BR>
		<BR>

	<LI><B>Review</B>
		<BR><BR>
		Once you've gotten the product you can review it and request any reasonable modifications to it that you require.  After you're satisfied, you pay me the remaining amount owed (if any).  If you are <I>not</I> satisfied, please see my <A HREF="#guarantee">options</A> for what you can do.<BR>
		<BR>

</OL>

<A NAME="guarantee"><H2>Satisfaction Guarantee</H2></A>

I believe in quality work, integrity, and honest communication.  Thus, I guarantee your satisfaction with my services.  If, for any valid reason, you are not satisfied you can seek to recoup payments or product ownership through one of the options available listed below.  Your satisfaction should be based on the promptness, friendliness, helpfulness, and accuracy of the service I provide, <B>not</B> on external factors that are beyond my control such as class grades or build issues on platforms I don't have access to.  I will make no refunds or guarantees if any of my <A HREF="#terms">terms of agreement</A> have been broken or disregarded, so please read those before hand.<BR>
<BR>
<OL>
	<LI><A NAME="fullrefund"><B>Full Refund</B></A> (minus processing fees)
		<BR><BR>
		If you request a full refund, I will send you the money back using <A HREF="http://www.paypal.com/">PayPal</A>, but you will relinquish the ownership of all that I have created for the duration of the contract.  This option is <I>only</I> available to clients whose contracts required a minimum of five (5) paid hours.  The refund amount will <I>not</I> include any fees taken out for payment processing done by those other than myself or my associates; <A HREF="http://www.paypal.com/">PayPal</A>, for example, takes out around five percent (5%).<BR>
		<BR>

	<LI><A NAME="forgofinal"><B>Forgo Final Payment</B></A>
		<BR><BR>
		If you request to forgo the final payment, I will keep only the deposit and you retain the full ownership of the project.  If you have paid more than your deposit, I will refund the difference.<BR>
		<BR>

	<LI><A NAME="claimbreak"><B>Claim Extreme Communication Breakdown</B></A>
		<BR><BR>
		If you feel that there was an extreme breakdown in communication that caused the results of the contract to come out completely unexpected from what you intended, I can allow the <A HREF="#fullrefund">Full Refund</A> option (above).  The result of this claim is up to my discretion and you should provide healthy arguments to back it up.<BR>
		<BR>
</OL>

For any challenge of my service guarantee, I request that you provide an explanation unless it is already obvious.  This will assist me in continuing to provide excellent products and services.<BR>
<BR>

<A NAME="faq"><H2>Frequently Asked Questions</H2></A>

<UL>

	<LI><B>Can you do projects in less time than you estimate and then charge less?</B>
		<BR><BR>
		Yes, but then I will not have sufficient time to add descriptive comments, properly test it to guarantee code/logic quality, and allow you to request reasonable modifications or to help trouble shoot issues you have.  In the end I <I>could</I> charge you less, but then I'd be writing code with minimal testing, no design considerations, you wouldn't be able to request modifications, and it wouldn't be supported my satisfaction guarantee.<BR>
		<BR>

	<LI><B>Why is this build problem my responsibility?</B>
		<BR><BR>
		I can only guarantee support for the build environments that I have <A HREF="#supplats">access to</A>.  Due to the cross-platform nature of most of the work I do, I can design and write projects intended to be built and run on other platforms.  However, by allowing me to do this you are accepting the fact that I can't assure hassle-free builds for those unsupported platforms.  Thus, it is ultimately your responsibility to get projects building on unsupported platforms.  I do help with trouble-shooting the problem, but since I don't have direct access I can't always be of much help.  This <I>doesn't</I> mean that I don't still promise the quality and validity of the project source or resulting binaries.<BR>
		<BR>

		I've done several small C++ contracts for CodeWarrior on the Macintosh, even though I do not own either, and I've helped trouble-shoot build problems there on occasion through emails.  Recently a client had problems with building the project in a Unix environment and expected me to solve them or let them pay less than was agreed upon.  That is what prompted me to change this entire services page so that clients are more informed about the terms of my contracts and what their options are.<BR>
		<BR>

		When there is a build problem beyond the scope of the files I designed,  For example, if you have me do a project destined to be built by CodeWarrior on the Mac or a Unix compiler, I can't make sure it builds properly on those and if you.  By accepting and paying for my services, you are acknowledging which software platforms I will guarantee hassle-free builds for.  <BR>
		<BR>

	<LI><B>If I get a low class grade on my assignment, can I get my money back?</B> /
		<B>Will you make your program look more like what my teacher expects?</B>
		<BR><BR>
		I don't distinguish projects by whether or not you want them done for a class, personal reasons, or business; they are all just contracts to be fulfilled and all moral distinctions are left to the client, not myself.  The basis for your satisfaction is how well I create the project based on the <I>specifications you give me</I> and the reasonable modifications you request.  It is <B>not</B> based on how well this project actually does in whatever context you need it, such as a class or business.<BR>
		<BR>
		Secondly, if you want my products to come out looking like something specific you should be forthcoming about that.  I don't relish the thought of doing something over after spending my time completely developing it.  If I have to overhaul something, then consider it a completely new contract.  Remember to <I>always</I> present all of your requirements and restrictions in the negotiation phase <I>before</I> I start in.<BR>
		<BR>

	<LI><B>What are your rates based on?</B> / <B>Why did your rates go up?</B>
		<BR><BR>
		My rates are based on four main things: how much I make at my current full-time job, a reflection of how valuable my time is, how much I am in demand, and lastly the kind of quality that can be expected.  As I continually gain experience and move up the career ladder I tend to push towards a higher salaray, because I improve in proficiency and skill; the time it takes for me to do something goes down while the quality goes up.  And the more requests I get, the more crowded my time becomes.  Thus, the need to boost my rates comes not only from necessary compensation, but as a means to weed out those who are serious.  And in the end if you don't think I'm to par, you are protected by my <A HREF="#guarantee">satisfaction guarantee</A>.<BR>
		<BR>

	<LI><B>If you're a software engineer, why don't you have something automatic to setup contracts?</B>
		<BR><BR>
		I've considered, on multiple occasions, setting up some sort of web-based application to manage all of this, but it's a part time thing and I much prefer communicating directly.  My customers have appreciated the fact that they can get immediate help and feedback through email, both before and after projects.<BR>
		<BR>

	<LI><B>Who have you done contracts for?</B>
		<BR><BR>
		Dozens of people from business men to desperate individuals.  I don't really distinguish between any category, because I always strive to provide the best experience in service.  I've contracted directly to National Press, Inc. for a few background management applications as well as indirectly to Microsoft for a couple full-time positions.  I can't list the countless individuals, because that would be invading their privacy.  Ironically, I've done more contracts now that it's part time work than when I tried it full time.<BR>
		<BR>

	<LI><B>How did you start contracting?</B>
		<BR><BR>
		By accident.  A guy emailed me who did contracting and couldn't handle all of his projects.  He sub-contracted to me to get a project done (C++ application).  That was the first time I'd ever done anything like it, and I enjoyed it.  I setup all the rules to begin with, created the product, and got paid.  I decided other people might want me to do things and I could provide them in my spare time, so I decided to add this section on my website to protect myself and my clients.<BR>
		<BR>

</UL>

<A NAME="terms"><H2>Terms of Agreement</H2></A>

<I>Please read these carefully to be sure you agree to them <I>before</I> requesting a contract of service.</I><BR>
<BR>
The following terms apply to and are agreed upon by the the client as it pertains to the person receiving services.  When the client makes an initial payment, they have agreed to these terms.  Any breach of these terms will result in product results and/or payment that may have been unexpected to the client.  All variable terms are based on my discretion, such as the meaning or extent of "adversity", "reasonable", and "affect".<BR>
<BR>

<OL>

	<LI> The cost of all projects will be given in hours as it applies to my current rate of <B>thirty dollars</B> ($30) an hour.<BR>
	<BR>

	<LI> All projects will require a minimum of <B>two</B> (2) paid hours.<BR>
	<BR>

	<LI> All payment will currently be made using <A HREF="http://www.paypal.com/">PayPal</A> to the email address <CODE><A HREF="mailto:masta@gibdon.com">masta@gibdon.com</A></CODE>.<BR>
	<BR>

	<LI> Projects will not begin until a sufficient deposit is made by the client.  This deposit will be the greater of $250 and &frac14;, but no more than &frac12;.  The deposit signifies that the client has read this entire document and accepts these terms.  The client is free to send more than the minimum deposit with their initial payment.<BR>
	<BR>

	<LI> The agreed price of a contract will not be altered by events beyond reasonable context or otherwise unrelated to the services being provided, such as assignment grades or issues with environments inaccessible to me.<BR>
	<BR>

	<LI> I am not liable for issues on any platform I do not directly support (that I do not have direct access to) including build environments, operating systems, and build tools such as compilers; nor shall issues with these "unsupported platforms" adversly affect the negotiation agreements, such as specifications and cost.  I shall make a reasonable attempt to correctly produce for and trouble-shoot problems on these platforms, but compatibility is not guaranteed.  For all cross-platform work I will strive to remain the utmost compatible, usually be adhering to standards such as with C++.  Thus, most resulting source code will be completely functional on unsupported systems, but it still cannot be guaranteed.  Limited trouble-shooting for unsupported platforms is available through reasonable email communication between myself and the client.<BR>
	<BR>
	<A NAME="supplats"></A><B>Directly supported C++ software</B> currently includes Microsoft Visual C++ 6.0, Microsoft Visual C++ 7 (.NET), MinGW (includes Dev-C++), Borland C++ 5, Borland C++Builder 5.5 (free compiler), DJGPP, and Digital Mars.  <B>Directly supported operating systems</B> currently include Windows 98, Windows 2000, Windows XP, BeOS R5, and RedHat Linux.  Any product not explicitely listed in this current paragraph should be considered "unsupported".<BR>
	<BR>

	<LI> Source code for all languages used will be valid based on <I>current</I> standards, usage, and/or consensus.  If a problem occurs using the source code written and it is found <B>not</B> to be related to it's (the source code) validity, there shall be no liability to myself nor shall it adversely affect the agreed upon terms and pricing.<BR>
	<BR>

	<LI> All contact and project information is considered to be private and under the sole ownership of the client.  None of this data will be shared without the consent of the client and/or request from authentic authorities.<BR>
	<BR>

	<LI> The client may request reasonable modifications to the contract product after it has been delivered.  Modifications should not violate the original contract specifications.<BR>
	<BR>

	<LI> Products will be delivered via email enclosed within ZIP archives as well as posted to a download location on this or another web server.  The client may request alternative obtainment or delivery methods.<BR>
	<BR>

</OL>
