/****************************** File Prologue *******************************

University of Maryland University College
Introductory Programming in C/C++
CMIS-140
Section xxxx

~~~~~~~~~~
ASSIGNMENT
~~~~~~~~~~
Programming Project 6

~~~~~~~~~
FILE NAME
~~~~~~~~~
test_rational.cpp

~~~~~~
AUTHOR
~~~~~~
<Your Name>
<Your e-mail address>

~~~~~~~~~~~
DESCRIPTION
~~~~~~~~~~~

1. Analysis

1. Analysis

    1.1 Description
    This file contains the client functions to test the Rational class.
    Most operations performed by this program are arithmetic and logic
    operations. These operations apply to two operands. Since the two
    operands are normally located on the left and right side of the
    operator, I have called these operands "left" and "right".

    ********************************************************************
    * These objects are what the textbook example calls num1 and num2. *
    ********************************************************************

    1.2 Inputs (Definition, Type, Format, Valid Range)

        1.2.1 Operation Request
        This input instructs the program what operation the user is requesting
        to be performed on the two operands, left and right.

        Type: Character
        Format: N/A
        Valid range: Only the following characters yield a valid operation:
                     +, -, *, /. =, l, L, r, R, ?, Q

        1.2.2 Rational Number input
        If the user selects, l or R, the program will accept a rational number
        as an input and store it in the left or right operand respectively.

        Type/Format/Range: Integer/Integer

    1.3 Outputs (Definition, Type, Format, Valid Range)

        1.3.1 Program Menu
        The program menu instructs the user on the operation of the program:

        1.3.2 Operation result
        The program will always output automatically the result of the
        operation performed.

        Type/Format/Range: Integer/Integer

    1.4 Error Handling

        Prevents divide by zero in a division.

    1.5 Special Considerations

2. Design
    1.1 Instruct the user
    1.2 Wait for user operation
    1.3 Perform user operation
        1.3.1 If user operation is +, perform Rational::AddTo
        1.3.2 If user operation is -, perform rational::subtract
        1.3.3 If user operation is *, perform Rational::multiplyBy
        1.3.4 If user operation is /
            1.3.4.1 If divisor of the rational number division operation is
                    a zero, display an error message
            1.3.4.2 Else perform Rational::divideBy
        1.3.5 If user operation is =, perform Rational::isEqualTo and
              display appropriate messages
        1.3.6 If user operation is L or l, read into the left operand
        1.3.7 If user operation is R or r, read into the right operand
        1.3.8 If user operation is S or s, swap left and right operands
        1.3.9 If user operation is ?, diaplay the menu
        1.3.10 If user operation is Q or q, Quit the program

    1.4 Repeat 1.3

****************************************************************************/

/*------------------------------ [INCLUDES] -------------------------------*/
#include "rational.h"   // for using class Rational


/*----------------------------- [DATA TYPES] ------------------------------*/
//NONE


/*--------------------------- [GLOBAL CONSTANTS] --------------------------*/
//NONE


/*--------------------------- [GLOBAL VARIABLES] --------------------------*/
//NONE

/*-------------------------- [FUNCTION PROTOTYPES] ------------------------*/
void WriteMenu(const Rational, const Rational);
void InstructUser ();


/*---------------------------- [FUNCTION BODIES] --------------------------*/


/************************** Function Description ****************************

~~~~~~~~~~~~~
FUNCTION NAME
~~~~~~~~~~~~~
main

~~~~~~~~~~~~~~~~~~~~
FUNCTION DESCRIPTION
~~~~~~~~~~~~~~~~~~~~
This function is the main executive to test the Rational class.

Formal Parameter    I/O                         Description
================    ===       ===============================================
none                 -        -

****************************************************************************/


int main()
{
    char operationRequest;

    Rational left, right(3, 4), result;

    InstructUser();

    WriteMenu(left, right);

    do
    {

        cout << "Enter choice:  ";
        cin >> operationRequest;
        operationRequest = static_cast<char>(toupper(operationRequest));

        switch(operationRequest)
        {
            case '+':
            {
                // add right to left
                result = left.Add(right);

                left.Write(cout);

                cout << " + ";

                right.Write(cout);

                cout << " = ";

                result.Write(cout);

                cout << endl;

                break;
            }

            case '-':
            {
                // subtract right from left
                result = left.Subtract(right);

                left.Write(cout);

                cout << " - ";

                right.Write(cout);

                cout << " = ";

                result.Write(cout);

                cout << endl;

                break;
            }

            case '*':
            {
                // multiply left and right
                result = left.Multiply(right);

                left.Write(cout);

                cout << " * ";

                right.Write(cout);

                cout << " = ";

                result.Write(cout);

                cout << endl;

                break;
            }

            case '/':
            {
                // divide left by right
                Rational::DivideStatus divStat;

                result = left.Divide(right, divStat);

                // show the expression if the division was a success
                if (divStat == Rational::SUCCESS)
                {
                    left.Write(cout);

                    cout << " / ";

                    right.Write(cout);

                    cout << " = ";

                    result.Write(cout);

                    cout << endl;
                }
                // else if there was an error ... tell the user
                else
                {
                    cout << "Error dividing ";

                    left.Write(cout);

                    cout << " by ";

                    right.Write(cout);

                    cout << ": ";

                    if (divStat == Rational::DIVIDE_BY_ZERO)
                    {
                        cout << "Divided by zero!" << endl;
                    }
                    else
                    {
                        cout << "Unknown!" << endl;
                    }
                }

                break;
            }
            case '=':
            {
                left.Write(cout);

                // compare left and right
                if (left.IsEqualTo(right))
                {
                    cout << " is equal to ";
                }
                else
                {
                    cout << " is NOT equal to ";
                }

                right.Write(cout);

                cout << endl;

                break;
            }

            case 'L':
            {
                // read into left
                cout << "Input left fraction in 'numerator/denominator' form: ";

                left.Read(cin);

                cout << "Left == ";

                left.Write(cout);

                cout << endl;

                break;
            }

            case 'R':
            {
                // read into right
                cout << "Input right fraction in 'numerator/denominator' form: ";

                right.Read(cin);

                cout << "Right == ";

                right.Write(cout);

                cout << endl;

                break;
            }

            case 'S':
            {
                // swap left and right using 'result' to temporarily hold 'left'
                result = left;
                left = right;
                right = result;

                // break intentionally left out so the menu is automatically
                // displayed after the swap, just a matter of convenience and
                // to show that you can do so.

            }

            case '?':

            {
                WriteMenu(left, right);
                break;
            }

            case 'Q':
            {
                break;
            }

            default:
            {
                cout << "*** INVALID OPERATION ***" << endl;
                WriteMenu(left, right);
            }
        }
    }
    while(operationRequest != 'Q');

    return 0;
}

/************************** Function Description ****************************

~~~~~~~~~~~~~
FUNCTION NAME
~~~~~~~~~~~~~
InstructUser

~~~~~~~~~~~~~~~~~~~~
FUNCTION DESCRIPTION
~~~~~~~~~~~~~~~~~~~~
This function instructs the user on how to use the program.

Formal Parameter    I/O                         Description
================    ===       ===============================================
none                 -        -

****************************************************************************/
void InstructUser ()
{

    cout << "This test driver works with up to two fractions acting as "   << endl;
    cout << "operands for various operations." << endl;
    cout << "These operands are left and write operands of an arithmetic " << endl;
    cout << "operation. Let's call the operands \"LEFT\" and \"RIGHT\" "   << endl;
    cout << endl;
}

/************************** Function Description ****************************

~~~~~~~~~~~~~
FUNCTION NAME
~~~~~~~~~~~~~
WriteMenu

~~~~~~~~~~~~~~~~~~~~
FUNCTION DESCRIPTION
~~~~~~~~~~~~~~~~~~~~
This function displays the user interface menu for the program.

Formal Parameter    I/O                         Description
================    ===       ===============================================
none                 -        -

****************************************************************************/

void WriteMenu(const Rational left, const Rational right)
{
    cout << "LEFT = "; left.Write(cout); cout << endl;
    cout << "RIGHT = "; right.Write(cout); cout << endl;
    cout << endl;

    cout << "Enter the character in (parentheses) to choose an operation:\n"
         << endl;
    cout << "(+) Add LEFT and RIGHT      (-) Subtract RIGHT from LEFT" << endl;
    cout << "(*) Multiply LEFT by RIGHT  (/) Divide LEFT by RIGHT"     << endl;
    cout << "(L) read LEFT               (R) read RIGHT\n"             << endl;

    cout << "(=) is LEFT equal to RIGHT?"                              << endl;
    cout << "(S) swap LEFT and RIGHT\n"                                << endl;

    cout << "(?) display this menu       (Q)quit program"              << endl;

    cout << endl << endl;
}
