//------------------------------------------------------------------------------
// File: wedge.h
// Desc: Declaration and Definitions for 'wedge' class.
//------------------------------------------------------------------------------
#ifndef _WEDGE_H
#define _WEDGE_H

//_[headers]____________________________________________________________________
//
#include "triangle.h"		// flat triangle class, used as base for wedge
#include <iostream.h>		// i/o streaming (cout)

//_[wedge class]________________________________________________________________
//
class wedge : public triangle
{
public:

	//--------------------------------------------------------------------------
	// Name: wedge()
	// Desc: Constructor.
	//--------------------------------------------------------------------------
	wedge(float NewSide1 = 3.0, float NewSide2 = 4.0, float NewSide3 = 5.0,
			float NewHeight = 14.3)
	: Height	(NewHeight)
	, triangle	(NewSide1, NewSide2, NewSide3)
	{
	}

	//--------------------------------------------------------------------------
	// Name: print()
	// Desc: Displays info about wedge (see comment for 'shape::print()').
	//--------------------------------------------------------------------------
	virtual print()
	{
		cout << "Wedge:" << endl;
		cout << "Volume of wedge is " << volume() << endl;
		cout << "Area of wedge is " << area() << endl;
		cout << "Perimeter of base triangle is " << perimeter() << endl;
		cout << "Sides of base triangle are " << Side1 << ", " << Side2 << ", "
			<< Side3 << endl;
		cout << "Height of wedge is " << Height << endl;
	}

protected:

	//--------------------------------------------------------------------------
	// Name: area()
	// Desc: Calculates the area of the wedge.  This would be the surface of
	//		all sides: the two triangular sides for the top and bottom, and the
	//		three rectangle sides.
	//--------------------------------------------------------------------------
	float area()
	{
		return (Side1 * Height) + (Side2 * Height) +  (Side3 * Height) +
				triangle::area() * 2;
	}

	//--------------------------------------------------------------------------
	// Name: volume()
	// Desc: Calculates the volume of the wedge.
	//--------------------------------------------------------------------------
	float volume()
	{
		return triangle::area() * Height;
	}

	//--------------------------------------------------------------------------
	// Name: Height
	// Desc: Height of wedge.
	//--------------------------------------------------------------------------
	float Height;

}; // wedge

#endif